

package gov.grants.apply.util;

// Sun

import java.sql.Connection;
import java.sql.DriverManager;

import org.apache.log4j.Logger;

/**
 * Utility class for configuring and creating
 * Connections.
 * @author Brian Husted
 *
 *
 */
public final class DBUtils {
	final static Logger log = Logger.getLogger(DBUtils.class.getName());
	

	private DBUtils() {/*no instances needed*/}
	
	static {

		try {			
			Class.forName( Utils.getProperty("DB_CLASS") );

		} catch (Throwable t) {
			log.fatal("Unable to establish DataSource!!", t);
		}
		
	}


	/**
	 * @return Returns the log.
	 */
	private static Logger getLog() {
		return log;
	}
	

	/**
	 * Creates a new Connection object.
	 * @return the Connection.
	 * @throws Exception
	 */
	public static Connection getConnection() throws Exception {

		return  DriverManager.
        getConnection(Utils.getProperty("DB_URL"), Utils.getProperty("DB_USER_NAME"), Utils.getProperty("DB_PASSWORD") );

	}
	
}// DBUtils
