/*
 * Created on Jun 24, 2004
 *
 */
package gov.grants.apply.ws;

import gov.grants.apply.axis.util.AxisUtils;

import java.security.cert.X509Certificate;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;

import org.apache.log4j.Logger;

import com.trw.InFlowSuiteCustomization.Grants_gov.CustomerDefinedClasses.GGWSWrapper;

/**
 * Provides useful methods for WSPRocessor classes.
 * 
 * @author Brian Husted
 */
public abstract class AbstractWSProcessor implements WSProcessor {
	static final Logger log = Logger.getLogger(AbstractWSProcessor.class
			.getName());

	/**
	 * Gets the current user's ID from the digital certificate provided in the
	 * SSL handshake.
	 * 
	 * @return
	 * @throws Exception
	 */
	public static String getUserId() throws Exception {
		HttpServletRequest request = AxisUtils.getCurrentHttpRequest();
		HttpSession session = request.getSession(true);
		if (session != null) {
			log.debug("The HttpServletRequest contains a valid session");
		} else {
			log.debug("The HttpServletRequest does not have a valid session");
		}

		String userId = GGWSWrapper.getID(request);
		log.debug("The user id is: " + userId);
		return userId;
	}

}