/*
 * Created on Jun 24, 2004
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package gov.grants.apply.ws;

import gov.grants.apply.WebServices.ApplicantIntegrationServices_V1_0.OpportunityInformationType;
import gov.grants.apply.WebServices.ApplicantIntegrationServices_V1_0._GetOpportunityListRequest;
import gov.grants.apply.WebServices.ApplicantIntegrationServices_V1_0._GetOpportunityListResponse;
import gov.grants.apply.dao.GetOpportunityListDao;
import gov.grants.apply.system.Global_V1_0.StringMin1Max100Type;
import gov.grants.apply.system.Global_V1_0.StringMin1Max15Type;
import gov.grants.apply.system.Global_V1_0.StringMin1Max255Type;
import gov.grants.apply.valueObject.GetOpportunityList;

import java.sql.Connection;
import java.util.ArrayList;
import java.util.Date;
import java.util.Iterator;
import java.util.List;

import org.apache.log4j.Logger;

/**
 * Processes a GetOpportunityList Web Service Request.
 * 
 * @author Feng Qian
 * 
 */
public class GetOpportunityListProcessor_RI extends AbstractWSProcessor_RI {
	static final Logger log = Logger
			.getLogger(GetOpportunityListProcessor_RI.class.getName());

	/**
	 * @param request the Object of the webservice request.
	 * @return the Object of the opportunities.
	 */
	public Object processRequest(Object request) throws Exception {

		//========================================================
		// Declaration of variables
		//========================================================

		_GetOpportunityListRequest getOpportunityListRequest = (_GetOpportunityListRequest) request;
		_GetOpportunityListResponse response = new _GetOpportunityListResponse();

		Connection conn = null;
		try {
			//=======================================================
			// Getting connection with DAO and converting values
			// from GetOpportunityRequest datatypes to String datatypes.
			// Call the "load" method from the dao
			// =======================================================
			conn = getConnection();

			String reqOppID = hasValue(getOpportunityListRequest
					.getOpportunityID()) ? getOpportunityListRequest
					.getOpportunityID().getValue() : "";

			String reqCfda = hasValue(getOpportunityListRequest.getCFDANumber())
				? getOpportunityListRequest.getCFDANumber().getValue(): "";
				
			String reqCompID = hasValue(getOpportunityListRequest
					.getCompetitionID()) ? getOpportunityListRequest
					.getCompetitionID().getValue() : "";

			GetOpportunityList getOpp = new GetOpportunityList();
			//===========================================
			getOpp.setOPPORTUNITY_ID(reqOppID);
			getOpp.setCFDA_NUMBER(reqCfda);
			getOpp.setCOMPETITION_ID(reqCompID);

			//==========================================================
			// Converting String datatypes from the database to
			// StringMinMaxType which is needed by the
			// _GetOpportunityListResponse class
			//It is also placed in the OpportunityInformationType object
			//===========================================================
			
			GetOpportunityListDao dao = new GetOpportunityListDao();
			//=============================================
			List l = dao.searchMatching(conn, getOpp);


			if (l != null) {
				List oppList = new ArrayList();
				Iterator i = l.iterator();
				int ctr = 0;
				while (i.hasNext()) {
					OpportunityInformationType oppInfoType =
						new OpportunityInformationType();
					//===============================================
					GetOpportunityList opp = (GetOpportunityList) i.next();

					if (opp.getOPPORTUNITY_ID() != null) {
						StringMin1Max100Type respOppID = 
							new StringMin1Max100Type(opp.getOPPORTUNITY_ID());
						oppInfoType.setOpportunityID(respOppID);
					}
					if (opp.getOPPORTUNITY_TITLE() != null) {
						StringMin1Max255Type respTitle = 
							new StringMin1Max255Type(opp
									.getOPPORTUNITY_TITLE());
						oppInfoType.setOpportunityTitle(respTitle);
					}
					if (opp.getOPENING_DATE() > 0) {
						Date OpeningDate = new Date(opp.getOPENING_DATE());
						oppInfoType.setOpeningDate(OpeningDate);
					}
					if (opp.getCLOSING_DATE() > 0) {
						Date ClosingDate = new Date(opp.getCLOSING_DATE());
						oppInfoType.setClosingDate(ClosingDate);
					}
					if (opp.getCFDA_NUMBER() != null) {
						StringMin1Max15Type respCFDA = new StringMin1Max15Type(
								opp.getCFDA_NUMBER());
						oppInfoType.setCFDANumber(respCFDA);
					}
					if (opp.getCOMPETITION_ID() != null) {
						StringMin1Max100Type respComp = 
							new StringMin1Max100Type(opp.getCOMPETITION_ID());
						oppInfoType.setCompetitionID(respComp);
					}
					log.debug(getOpp.getSCHEMA_URL());
					if (opp.getSCHEMA_URL() != null) {
						oppInfoType.setSchemaURL(opp.getSCHEMA_URL());
						
					}
					log.debug(getOpp.getINSTRUCTION_URL());
					if (opp.getINSTRUCTION_URL() != null) {
						oppInfoType.setInstructionURL(opp
								.getINSTRUCTION_URL());
					}
					

					oppList.add(oppInfoType);

				}

				response
				 .setOpportunityInformation(
				 		(OpportunityInformationType[]) oppList
				   .toArray(new OpportunityInformationType[0]));

			}


		} finally {
			try {
				//========================================================
				// Close connection to the dao and database
				//========================================================
				conn.close();
			} catch (Exception ex) {
			
			}
		}

		return response;

	}

	/**
	 * @param o an object.
	 * @return a true if the object is not null, a false if the object is null.
	 */
	protected static boolean hasValue(Object o) {
		if (o != null) {
			return true;
		}
		return false;

	}

}